Merge commit 'dkg/master'
[monkeysphere.git] / src / monkeysphere-server
index a5497c29e06a36b94e827a9407dc8a4095d35184..3ca0656e4ad5168b48a6282c4174a25f301168ce 100755 (executable)
@@ -32,29 +32,31 @@ RETURN=0
 ########################################################################
 
 usage() {
-cat <<EOF
+    cat <<EOF
 usage: $PGRM <subcommand> [options] [args]
 MonkeySphere server admin tool.
 
 subcommands:
-  update-users (u) [USER]...            update users authorized_keys files
-
-  gen-key (g) [HOSTNAME]                generate gpg key for the server
-    -l|--length BITS                      key length in bits (2048)
-    -e|--expire EXPIRE                    date to expire
-    -r|--revoker FINGERPRINT              add a revoker
-  show-fingerprint (f)                  show server's host key fingerprint
-  publish-key (p)                       publish server's host key to keyserver
-
-  add-identity-certifier (a) KEYID      import and tsign a certification key
-    -n|--domain DOMAIN                    domain of certifier ()
-    -t|--trust TRUST                      trust level of certifier ('full')
-    -d|--depth DEPTH                      trust depth for certifier (1)
-  remove-identity-certifier (r) KEYID   remove a certification key
-  list-identity-certifiers (l)          list certification keys
-
-  help (h,?)                            this help
-
+ update-users (u) [USER]...          update user authorized_keys files
+
+ gen-key (g) [HOSTNAME]              generate gpg key for the server
+   -l|--length BITS                    key length in bits (2048)
+   -e|--expire EXPIRE                  date to expire
+   -r|--revoker FINGERPRINT            add a revoker
+ show-fingerprint (f)                show server's host key fingerprint
+ publish-key (p)                     publish server's host key to keyserver
+ diagnostics (d)                     report on the server's monkeysphere status
+
+ add-identity-certifier (a) KEYID    import and tsign a certification key
+   -n|--domain DOMAIN                  limit ID certifications to IDs in DOMAIN
+   -t|--trust TRUST                    trust level of certifier (full)
+   -d|--depth DEPTH                    trust depth for certifier (1)
+ remove-identity-certifier (r) KEYID remove a certification key
+ list-identity-certifiers (l)        list certification keys
+
+ gpg-authentication-cmd CMD          gnupg-authentication command
+
+ -h|--help|help (h,?)                this help
 EOF
 }
 
@@ -141,13 +143,15 @@ update_users() {
 
        log "----- user: $uname -----"
 
+        # exit if the authorized_user_ids file is empty
        if ! check_key_file_permissions "$uname" "$AUTHORIZED_USER_IDS" ; then
-           log "Improper permissions on authorized_user_ids file."
+           log "Improper permissions on authorized_user_ids file path."
            continue
        fi
 
+       # check permissions on the authorized_keys file path
        if ! check_key_file_permissions "$uname" "$RAW_AUTHORIZED_KEYS" ; then
-           log "Improper permissions on authorized_keys file."
+           log "Improper permissions on authorized_keys file path path."
            continue
        fi
 
@@ -204,8 +208,7 @@ update_users() {
        chgrp $(getent passwd "$uname" | cut -f4 -d:) "$AUTHORIZED_KEYS"
        chmod g+r "$AUTHORIZED_KEYS"
 
-       # if the resulting authorized_keys file is not empty, move
-       # it into place
+       # move the resulting authorized_keys file into place
        mv -f "$AUTHORIZED_KEYS" "${VARLIB}/authorized_keys/${uname}"
 
        # destroy temporary directory
@@ -215,11 +218,56 @@ update_users() {
 
 # generate server gpg key
 gen_key() {
+    local keyType
+    local keyLength
+    local keyUsage
+    local keyExpire
+    local revoker
     local hostName
     local userID
     local keyParameters
     local fingerprint
 
+    # set default key parameter values
+    keyType="RSA"
+    keyLength="2048"
+    keyUsage="auth"
+    keyExpire=
+    revoker=
+
+    # get options
+    TEMP=$(getopt -o e:l:r -l expire:,length:,revoker: -n "$PGRM" -- "$@")
+
+    if [ $? != 0 ] ; then
+       exit 1
+    fi
+
+    # Note the quotes around `$TEMP': they are essential!
+    eval set -- "$TEMP"
+
+    while true ; do
+       case "$1" in
+           -l|--length)
+               keyLength="$2"
+               shift 2
+               ;;
+           -e|--expire)
+               keyExpire="$2"
+               shift 2
+               ;;
+           -r|--revoker)
+               revoker="$2"
+               shift 2
+               ;;
+           --)
+               shift
+               ;;
+            *)
+               break
+               ;;
+       esac
+    done
+
     hostName=${1:-$(hostname --fqdn)}
     userID="ssh://${hostName}"
 
@@ -228,12 +276,8 @@ gen_key() {
        failure "Key for '$userID' already exists"
     fi
 
-    # set key variables
-    KEY_TYPE="RSA"
-    KEY_LENGTH=${KEY_LENGTH:="2048"}
-    KEY_USAGE="auth"
     # prompt about key expiration if not specified
-    if [ -z "$KEY_EXPIRE" ] ; then
+    if [ -z "$keyExpire" ] ; then
        cat <<EOF
 Please specify how long the key should be valid.
          0 = key does not expire
@@ -242,33 +286,33 @@ Please specify how long the key should be valid.
       <n>m = key expires in n months
       <n>y = key expires in n years
 EOF
-       while [ -z "$KEY_EXPIRE" ] ; do
-           read -p "Key is valid for? (0) " KEY_EXPIRE
-           if ! test_gpg_expire ${KEY_EXPIRE:=0} ; then
+       while [ -z "$keyExpire" ] ; do
+           read -p "Key is valid for? (0) " keyExpire
+           if ! test_gpg_expire ${keyExpire:=0} ; then
                echo "invalid value"
-               unset KEY_EXPIRE
+               unset keyExpire
            fi
        done
-    elif ! test_gpg_expire "$KEY_EXPIRE" ; then
-       failure "invalid key expiration value '$KEY_EXPIRE'."
+    elif ! test_gpg_expire "$keyExpire" ; then
+       failure "invalid key expiration value '$keyExpire'."
     fi
 
     # set key parameters
     keyParameters=$(cat <<EOF
-Key-Type: $KEY_TYPE
-Key-Length: $KEY_LENGTH
-Key-Usage: $KEY_USAGE
+Key-Type: $keyType
+Key-Length: $keyLength
+Key-Usage: $keyUsage
 Name-Real: $userID
-Expire-Date: $KEY_EXPIRE
+Expire-Date: $keyExpire
 EOF
 )
 
     # add the revoker field if specified
     # FIXME: the "1:" below assumes that $REVOKER's key is an RSA key.
     # FIXME: key is marked "sensitive"?  is this appropriate?
-    if [ "$REVOKER" ] ; then
+    if [ "$revoker" ] ; then
        keyParameters="${keyParameters}"$(cat <<EOF
-Revoker: 1:$REVOKER sensitive
+Revoker: 1:$revoker sensitive
 EOF
 )
     fi
@@ -299,6 +343,10 @@ EOF
     fingerprint=$(gpg_host --list-key --with-colons --with-fingerprint "=${userID}" | \
        grep '^fpr:' | head -1 | cut -d: -f10)
 
+    # export host ownertrust to authentication keyring
+    log "setting ultimate owner trust for server key..."
+    echo "${fingerprint}:6:" | gpg_authentication "--import-ownertrust"
+
     # translate the private key to ssh format, and export to a file
     # for sshs usage.
     # NOTE: assumes that the primary key is the proper key to use
@@ -315,7 +363,7 @@ fingerprint_server_key() {
 
 # publish server key to keyserver
 publish_server_key() {
-    read -p "really publish key to $KEYSERVER? (y/N) " OK; OK=${OK:=N}
+    read -p "Really publish key to $KEYSERVER? (y/N) " OK; OK=${OK:=N}
     if [ ${OK/y/Y} != 'Y' ] ; then
        failure "aborting."
     fi
@@ -324,25 +372,195 @@ publish_server_key() {
     # FIXME: need to figure out better way to identify host key
     # dummy command so as not to publish fakes keys during testing
     # eventually:
-    #gpg_authentication "--keyring $GNUPGHOME_HOST/pubring.gpg --keyserver $KEYSERVER --send-keys $(hostname -f)"
-    failure "NOT PUBLISHED (to avoid permanent publication errors during monkeysphere development)."
+    #gpg_authentication "--keyserver $KEYSERVER --send-keys $(hostname -f)"
+    echo "NOT PUBLISHED (to avoid permanent publication errors during monkeysphere development)."
+    echo "The following command should publish the key:"
+    echo "monkeysphere-server gpg-authentication-cmd '--keyserver $KEYSERVER --send-keys $(hostname -f)'"
+    exit 255
+}
+
+diagnostics() {
+#  * check on the status and validity of the key and public certificates
+    local seckey
+    local keysfound
+    local curdate
+    local warnwindow
+    local warndate
+    local create
+    local expire
+    local uid
+    local fingerprint
+    local badhostkeys
+
+    seckey=$(gpg_host --list-secret-keys --fingerprint --with-colons --fixed-list-mode)
+    keysfound=$(echo "$seckey" | grep -c ^sec:)
+    curdate=$(date +%s)
+    # warn when anything is 2 months away from expiration
+    warnwindow='2 months'
+    warndate=$(date +%s -d "$warnwindow")
+
+    echo "Checking host GPG key..."
+    if (( "$keysfound" < 1 )); then
+       echo "! No host key found."
+       echo " - Recommendation: run 'monkeysphere-server gen-key'"
+    elif (( "$keysfound" > 1 )); then
+       echo "! More than one host key found?"
+       # FIXME: recommend a way to resolve this
+    else
+       create=$(echo "$seckey" | grep ^sec: | cut -f6 -d:)
+       expire=$(echo "$seckey" | grep ^sec: | cut -f7 -d:)
+       fingerprint=$(echo "$seckey" | grep ^fpr: | head -n1 | cut -f10 -d:)
+       # check for key expiration:
+       if [ "$expire" ]; then
+           if (( "$expire"  < "$curdate" )); then
+               echo "! Host key is expired."
+               # FIXME: recommend a way to resolve this other than re-keying?
+           elif (( "$expire" < "$warndate" )); then
+               echo "! Host key expires in less than $warnwindow:" $(date -d "$(( $expire - $curdate )) seconds" +%F)
+               # FIXME: recommend a way to resolve this?
+           fi
+       fi
+
+        # and weirdnesses:
+       if [ "$create" ] && (( "$create" > "$curdate" )); then
+           echo "! Host key was created in the future(?!). Is your clock correct?"
+           echo " - Recommendation: Check clock ($(date +%F_%T)); use NTP?"
+       fi
+
+        # check for UserID expiration:
+       echo "$seckey" | grep ^uid: | cut -d: -f6,7,10 | \
+       while IFS=: read create expire uid ; do
+           # FIXME: should we be doing any checking on the form
+           # of the User ID?  Should we be unmangling it somehow?
+
+           if [ "$create" ] && (( "$create" > "$curdate" )); then
+               echo "! User ID '$uid' was created in the future(?!).  Is your clock correct?"
+               echo " - Recommendation: Check clock ($(date +%F_%T)); use NTP?"
+           fi
+           if [ "$expire" ] ; then
+               if (( "$expire" < "$curdate" )); then
+                   echo "! User ID '$uid' is expired."
+                       # FIXME: recommend a way to resolve this
+               elif (( "$expire" < "$warndate" )); then
+                   echo "! User ID '$uid' expires in less than $warnwindow:" $(date -d "$(( $expire - $curdate )) seconds" +%F)                
+                   # FIXME: recommend a way to resolve this
+               fi
+           fi
+       done
+           
+# FIXME: verify that the host key is properly published to the
+#   keyservers (do this with the non-privileged user)
+
+# FIXME: check that there are valid, non-expired certifying signatures
+#   attached to the host key after fetching from the public keyserver
+#   (do this with the non-privileged user as well)
+
+# FIXME: propose adding a revoker to the host key if none exist (do we
+#   have a way to do that after key generation?)
+
+       # Ensure that the ssh_host_rsa_key file is present and non-empty:
+       echo "Checking host SSH key..."
+       if [ ! -s "${VARLIB}/ssh_host_rsa_key" ] ; then
+           echo "! The host key as prepared for SSH (${VARLIB}/ssh_host_rsa_key) is missing or empty."
+       else
+           if [ $(stat -c '%a' "${VARLIB}/ssh_host_rsa_key") != 600 ] ; then
+               echo "! Permissions seem wrong for ${VARLIB}/ssh_host_rsa_key -- should be 0600."
+           fi
+
+           # propose changes needed for sshd_config (if any)
+           if ! grep -q "^HostKey[[:space:]]\+${VARLIB}/ssh_host_rsa_key$" /etc/ssh/sshd_config; then
+               echo "! /etc/ssh/sshd_config does not point to the monkeysphere host key (${VARLIB}/ssh_host_rsa_key)."
+               echo " - Recommendation: add a line to /etc/ssh/sshd_config: 'HostKey ${VARLIB}/ssh_host_rsa_key'"
+           fi
+           if badhostkeys=$(grep -i '^HostKey' | grep -q -v "^HostKey[[:space:]]\+${VARLIB}/ssh_host_rsa_key$") ; then
+               echo "! /etc/sshd_config refers to some non-monkeysphere host keys:"
+               echo "$badhostkeys"
+               echo " - Recommendation: remove the above HostKey lines from /etc/ssh/sshd_config"
+           fi
+       fi
+    fi
+
+# FIXME: look at the ownership/privileges of the various keyrings,
+#    directories housing them, etc (what should those values be?  can
+#    we make them as minimal as possible?)
+
+# FIXME: look to see that the ownertrust rules are set properly on the
+#    authentication keyring
+
+# FIXME:  make sure that at least one identity certifier exists
+
+    echo "Checking for MonkeySphere-enabled public-key authentication for users ..."
+    # Ensure that User ID authentication is enabled:
+    if ! grep -q "^AuthorizedKeysFile[[:space:]]\+${VARLIB}/authorized_keys/%u$" /etc/ssh/sshd_config; then
+       echo "! /etc/ssh/sshd_config does not point to monkeysphere authorized keys."
+       echo " - Recommendation: add a line to /etc/ssh/sshd_config: 'AuthorizedKeysFile ${VARLIB}/authorized_keys/%u'"
+    fi
+    if badauthorizedkeys=$(grep -i '^AuthorizedKeysFile' | grep -q -v "^AuthorizedKeysFile[[:space:]]\+${VARLIB}/authorized_keys/%u$") ; then
+       echo "! /etc/sshd_config refers to non-monkeysphere authorized_keys files:"
+       echo "$badauthorizedkeys"
+       echo " - Recommendation: remove the above AuthorizedKeysFile lines from /etc/ssh/sshd_config"
+    fi
+
+
 }
 
 # retrieve key from web of trust, import it into the host keyring, and
 # ltsign the key in the host keyring so that it may certify other keys
 add_certifier() {
+    local domain
+    local trust
+    local depth
     local keyID
     local fingerprint
     local ltsignCommand
+    local trustval
+
+    # set default values for trust depth and domain
+    domain=
+    trust=full
+    depth=1
+
+    # get options
+    TEMP=$(getopt -o n:t:d: -l domain:,trust:,depth: -n "$PGRM" -- "$@")
+
+    if [ $? != 0 ] ; then
+       exit 1
+    fi
+
+    # Note the quotes around `$TEMP': they are essential!
+    eval set -- "$TEMP"
+
+    while true ; do
+       case "$1" in
+           -n|--domain)
+               domain="$2"
+               shift 2
+               ;;
+           -t|--trust)
+               trust="$2"
+               shift 2
+               ;;
+           -d|--depth)
+               depth="$2"
+               shift 2
+               ;;
+           --)
+               shift
+               ;;
+            *)
+               break
+               ;;
+       esac
+    done
 
     keyID="$1"
+    if [ -z "$keyID" ] ; then
+       failure "You must specify the key ID of a key to add."
+    fi
     export keyID
 
-    # export host ownertrust to authentication keyring
-    gpg_host --export-ownertrust | gpg_authentication "--import-ownertrust"
-
     # get the key from the key server
-    gpg_authentication "--keyserver $KEYSERVER --recv-key '$keyID'" || failure
+    gpg_authentication "--keyserver $KEYSERVER --recv-key '$keyID'"
 
     # get the full fingerprint of a key ID
     fingerprint=$(gpg_authentication "--list-key --with-colons --with-fingerprint $keyID" | \
@@ -351,7 +569,8 @@ add_certifier() {
     echo "key found:"
     gpg_authentication "--fingerprint $fingerprint"
 
-    read -p "Are you sure you want to add this key as a certifier of users on this system? (y/N) " OK; OK=${OK:-N}
+    echo "Are you sure you want to add this key as a certifier of"
+    read -p "users on this system? (y/N) " OK; OK=${OK:-N}
     if [ "${OK/y/Y}" != 'Y' ] ; then
        failure "aborting."
     fi
@@ -359,23 +578,26 @@ add_certifier() {
     # export the key to the host keyring
     gpg_authentication "--export $keyID" | gpg_host --import
 
-    # default values for trust depth and domain
-    DOMAIN=${DOMAIN:-}
-    TRUST=${TRUST:-2}
-    DEPTH=${DEPTH:-1}
+    if [ "$trust" == marginal ]; then
+       trustval=1
+    elif [ "$trust" == full ]; then
+       trustval=2
+    else
+       failure "trust value requested ('$trust') was unclear (only 'marginal' or 'full' are supported)"
+    fi
 
     # ltsign command
     # NOTE: *all* user IDs will be ltsigned
     ltsignCommand=$(cat <<EOF
 ltsign
 y
-$TRUST
-$DEPTH
-$DOMAIN
+$trustval
+$depth
+$domain
 y
 save
 EOF
-)
+       )
 
     # ltsign the key
     echo "$ltsignCommand" | gpg_host --quiet --command-fd 0 --edit-key "$fingerprint"
@@ -390,6 +612,9 @@ remove_certifier() {
     local fingerprint
 
     keyID="$1"
+    if [ -z "$keyID" ] ; then
+       failure "You must specify the key ID of a key to remove."
+    fi
 
     # delete the requested key (with prompting)
     gpg_host --delete-key "$keyID"
@@ -403,6 +628,11 @@ list_certifiers() {
     gpg_host --list-keys
 }
 
+# issue command to gpg-authentication keyring
+gpg_authentication_cmd() {
+    gpg_authentication "$@"
+}
+
 ########################################################################
 # MAIN
 ########################################################################
@@ -445,60 +675,6 @@ COMMAND="$1"
 [ "$COMMAND" ] || failure "Type '$PGRM help' for usage."
 shift
 
-# unset option variables
-unset KEY_LENGTH
-unset KEY_EXPIRE
-unset REVOKER
-unset DOMAIN
-unset TRUST
-unset DEPTH
-
-# get options for key generation and add-certifier functions
-TEMP=$(getopt -o l:e:r:n:t:d: -l length:,expire:,revoker:,domain:,trust:,depth: -n "$PGRM" -- "$@")
-
-if [ $? != 0 ] ; then
-    usage
-    exit 1
-fi
-
-# Note the quotes around `$TEMP': they are essential!
-eval set -- "$TEMP"
-
-while true ; do
-    case "$1" in
-       -l|--length)
-           KEY_LENGTH="$2"
-           shift 2
-           ;;
-       -e|--expire)
-           KEY_EXPIRE="$2"
-           shift 2
-           ;;
-       -r|--revoker)
-           REVOKER="$2"
-           shift 2
-           ;;
-       -n|--domain)
-           DOMAIN="$2"
-           shift 2
-           ;;
-       -t|--trust)
-           TRUST="$2"
-           shift 2
-           ;;
-       -d|--depth)
-           DEPTH="$2"
-           shift 2
-           ;;
-       --)
-           shift
-           ;;
-        *)
-            break
-            ;;
-    esac
-done
-
 case $COMMAND in
     'update-users'|'update-user'|'u')
        update_users "$@"
@@ -516,17 +692,15 @@ case $COMMAND in
        publish_server_key
        ;;
 
+    'diagnostics'|'d')
+       diagnostics
+       ;;
+
     'add-identity-certifier'|'add-certifier'|'a')
-       if [ -z "$1" ] ; then
-           failure "You must specify a key ID."
-       fi
        add_certifier "$1"
        ;;
 
     'remove-identity-certifier'|'remove-certifier'|'r')
-       if [ -z "$1" ] ; then
-           failure "You must specify a key ID."
-       fi
        remove_certifier "$1"
        ;;
 
@@ -534,7 +708,11 @@ case $COMMAND in
        list_certifiers "$@"
        ;;
 
-    'help'|'h'|'?')
+    'gpg-authentication-cmd')
+       gpg_authentication_cmd "$@"
+       ;;
+
+    '--help'|'help'|'-h'|'h'|'?')
         usage
         ;;